<%@ page import="com.ether.WebHelper" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<script type="text/javascript">
    var InterfaceTemplate = Class.create( {

        initialize: function()
        {
            /** *********** CONTAINERS *********** **/
            this.containerTools = $( "#tools" );
            this.containerLogin = $( "#loginModule" );
            this.containerMenuData = $( "#menuData" );

            /** *********** VARIABLES *********** **/
            // TODO : vérifier cette adresse de webmaster !!!!
            this.language = '<spring:message code="language"/>';
            this.webmaster = "rboipsl@ipsl.jussieu.fr";
            this.jSONUser = <%=WebHelper.getJSONUser( request )%> ? <%=WebHelper.getJSONUser( request )%> : false;

            /** ************ CREATE ************ **/
            this.createLogin();
            this.createTools();
        },

        // CREATES ********************************************************
        createTools: function()
        {
            var backofficeButton = new Button( {value:'<spring:message code="label.backoffice"/>', parent:this.containerTools, id:"button_bo", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickBO, this )} );

            var mailButton = new Button( {value:'<spring:message code="label.mail"/>', parent:this.containerTools, id:"button_mail", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickMail, this )} );
            var languageButton = new Button( {value:'<spring:message code="label.language.to.switch"/>', parent:this.containerTools, id:"button_language", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickLanguage, this )} );
            var homeButton = new Button( {value:'<spring:message code="label.home"/>', parent:this.containerTools, id:"button_home", className: "red_button", classNameText:"red_button_text", onClick:this.onClickHome} );
        },

        createLogin: function()
        {
            var loginModule = new LoginButton( {parent:this.containerLogin, urlLogin:"project?methodName=login", urlLogout:"project?methodName=logout", webmaster: this.webmaster, isNeededInscription:true, callbackInscription:jQuery.proxy( this.onClickInscription, this ) } );
            loginModule.setJSONUser( this.jSONUser );
            loginModule.display();
            setLoginModule( this.loginModule );
        },

        // REQUESTS ********************************************************
        requestChangeLocale: function()
        {
            $.ajax( {
                url: "project?methodName=setLocale&language=<spring:message code="label.language.value.to.switch"/>",
                success:function()
                {
                    location.reload();
                }
            } );
        },

        // HANDLES ******************************************************** = retours ajax

        // EVENTS ********************************************************
        onClickBO: function()
        {
            document.location.href = "backoffice?methodName=home";
        },

        onClickHome: function()
        {
            document.location.href = "index.jsp";
        },

        onClickLanguage: function()
        {
            this.requestChangeLocale();
        },

        onClickMail: function()
        {
            document.location.href = "mailto:" + this.webmaster + "?subject=[TAPAS]";
        },

        onClickInscription: function()
        {
            var dataProtocol = "resources/jsp/dataProtocol_fr.jsp";
            if( "fr" != this.language )
                dataProtocol = "resources/jsp/dataProtocol_en.jsp";

            var $dialog = $( '<div></div>' )
                    .load( dataProtocol )
                    .dialog( {
                                 autoOpen: false,
                                 title: '<spring:message code="login.inscription" />',
                                 height:800,
                                 width:750
                             } );
            $dialog.dialog( 'open' );
        }

    } )
            ;

    /** ******************************* **/
    /** *********** ACCOUNT *********** **/
    /** ******************************* **/
    function onClickAcceptDataProtocol()
    {
        if( '' == $( "#lastName" ).val() || '' == $( "#email" ).val() || '' == $( "#password" ).val() )
        {
            showErrorAccount( null, "<spring:message code='login.dataProtocolFields'/>" );
            return;
        }

        if( $( "#checkboxUser" ).attr( 'checked' ) )
            createAccount();
        else
            showErrorAccount( null, "<spring:message code='login.dataProtocolAccept'/>" );
    }

    function createAccount()
    {
        var parametersUrl = "name=" + $( "#lastName" ).val() + "&firstName=" + $( "#firstName" ).val() + "&email=" + $( "#email" ).val() + "&pwd=" + $( "#password" ).val() + "&laboratory=" + $( "#laboratory" ).val() + "&country=" + $( "#country" ).val();
        var request = $.ajax( {
            url: "project?methodName=createAccount&" + parametersUrl,
            success:handleCreateAccount,
            error: showErrorAccount
        } );
    }

    function handleCreateAccount()
    {
        $( "#infosAccount" ).hide();
        $( "#infosAccount" ).removeClass( "containerErrors" );
        $( "#infosAccount" ).addClass( "containerInfos" );
        $( "#infosAccount" ).html( '<spring:message code="login.dataProtocol.account"/>' );
        $( "#infosAccount" ).show();
    }

    function showErrorAccount( result, text )
    {
        $( "#infosAccount" ).hide();
        $( "#infosAccount" ).removeClass( "containerInfos" );
        $( "#infosAccount" ).addClass( "containerErrors" );
        if( null != result )
            $( "#infosAccount" ).html( templateTexts[result.responseText] );
        else
            $( "#infosAccount" ).html( text );

        $( "#infosAccount" ).show();
    }

</script>
